<?php
/**
 * webEdition CMS
 *
 * $Rev: 342e215a2edb $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-03-21 11:07 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
/*
 * This is the template for tab languages. It contains the information screen
 * before deleting or installing languages
 */
require_once($_SERVER['DOCUMENT_ROOT'] . "/webEdition/we/include/we.inc.php");

$nextButton = we_html_button::create_button(we_html_button::NEXT, WEBEDITION_DIR . 'liveUpdate/liveUpdate.php?section=languages&update_cmd=languages&detail=selectLanguages');
$deleteButton = we_html_button::create_button(we_html_button::DELETE, 'javascript:document.we_form.submit()');

$languages = liveUpdateFunctions::getInstalledLanguages();

$languagesStr = '';
foreach($languages as $lng){

	if(WE_LANGUAGE == $lng){
		$lngBox = we_html_forms::checkbox($lng, false, 'deleteLanguages[]', '<i>' . $lng . ' (' . g_l('liveUpdate', '[languages][systemLanguage]') . ")</i>", false, '', '', true);
	} else if($GLOBALS['WE_LANGUAGE'] == $lng){
		$lngBox = we_html_forms::checkbox($lng, false, 'deleteLanguages[]', '<i>' . $lng . ' (' . g_l('liveUpdate', '[languages][usedLanguage]') . ")</i>", false, '', '', true);
	} else {
		$lngBox = we_html_forms::checkbox($lng, false, 'deleteLanguages[]', $lng, true);
	}
	$languagesStr .= we_html_element::div([], $lngBox);
}

$deletedLngs = $this->getData('deletedLngs');
$notDeletedLngs = $this->getData('notDeletedLngs');
$jsAlert = '';
if(!empty($deletedLngs)){
	$jsAlert .= g_l('liveUpdate', '[languages][languagesDeleted]') . '\n';
	foreach($deletedLngs as $lng){
		$jsAlert .= $lng . '\n';
	}
}
if(!empty($notDeletedLngs)){
	$jsAlert .= g_l('liveUpdate', '[languages][languagesNotDeleted]') . '\n';
	foreach($notDeletedLngs as $lng){
		$jsAlert .= $lng . '\n';
	}
}

$jsCmd = new we_base_jsCmd();
if($jsAlert){
	$jsCmd->addMsg($jsAlert, we_base_util::WE_MESSAGE_FRONTEND);
}

return liveUpdateTemplates::getHtml(g_l('liveUpdate', '[languages][headline]'), we_html_element::form(['name' => 'we_form'], we_html_element::hidden('section', 'languages') . '
' . g_l('liveUpdate', '[languages][installedLngs]') . '<br/>
' . $languagesStr . '<br/>
<table style="width:100%">
<tr>
	<td>' . g_l('liveUpdate', '[languages][showLanguages]') . '</td>
	<td>' . $nextButton . '</td>
</tr>
<tr>
	<td><br/></td>
</tr>
<tr>
	<td>' . g_l('liveUpdate', '[languages][deleteSelectedLanguages]') . '</td>
	<td>' . $deleteButton . '</td>
</tr>
</table>'), $jsCmd->getCmds());
