<?php

/**
 * webEdition CMS
 *
 * $Rev: fa498c312e65 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-29 23:14 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_banner_tree extends we_tree_base{

	protected function customJSFile(){
		return we_html_element::jsScript(JS_DIR . 'banner_tree.js', 'initTree();');
	}

	public static function getItems($ParentId, $Offset = 0, $Segment = 500, $sort = false){
		$items = [];
		$db = new DB_WE();
		$db->query('SELECT ID,ParentID,IsFolder,Text FROM ' . BANNER_TABLE . ' WHERE ParentID=' . $ParentId . ' ORDER BY IsFolder DESC,(text REGEXP "^[0-9]") DESC,ABS(text),Text');
		while($db->next_record()){
			$IsFolder = $db->f('IsFolder');
			$items[] = ($IsFolder ? [
				'id' => intval($db->f('ID')),
				'parentid' => intval($db->f('ParentID')),
				'text' => addslashes($db->f('Text')),
				'typ' => 'group',
				'open' => 0,
				'contenttype' => 'we/bannerFolder',
				'table' => BANNER_TABLE,
				'loaded' => 0,
				'checked' => false,
				] :
				[
				'id' => intval($db->f('ID')),
				'parentid' => intval($db->f('ParentID')),
				'text' => addslashes($db->f('Text')),
				'typ' => 'item',
				'open' => 0,
				'contenttype' => 'we/banner',
				'table' => BANNER_TABLE,
				]
				);
		}
		return $items;
	}

}
