<?php

/**
 * webEdition CMS
 *
 * $Rev: 0194cde98bae $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-12-19 02:49 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_doctype_tree extends we_tree_base{

	protected function customJSFile(){
		return we_html_element::jsScript(WE_JS_MODULES_DIR . 'mod_tree.js', "initTree('" . we_modules_info::DOCTYPE . "');");
	}

	public static function getItems($ParentID, $offset = 0, $segment = 500, $sort = false){
		$db = new DB_WE();

		$items = [];
		$dtq = we_doctype_docTypes::getDoctypeQuery($db, true);
		$db->query('SELECT dt.ID,dt.DocType,dt.ParentID,dt.IsFolder FROM ' . DOC_TYPES_TABLE . ' dt LEFT JOIN ' . FILE_TABLE . ' dtf ON dt.ParentFileID=dtf.ID ' . $dtq['join'] . ' WHERE ' . $dtq['where']);

		while($db->next_record(MYSQLI_ASSOC)){
			$items[] = [
				'id' => intval($db->f('ID')),
				'parentid' => $db->f('ParentID'),
				'text' => addslashes($db->f('DocType')),
				'typ' => $db->f('IsFolder') ? self::TYP_FOLDER : self::TYP_ITEM,
				'open' => 0,
				'disabled' => 0,
				'tooltip' => $db->f('ID'),
				'offset' => $offset,
				'contenttype' => ($db->f('IsFolder') ? we_base_ContentTypes::FOLDER : we_base_ContentTypes::DOCTYPE),
				'published' => 1,
				'table' => DOC_TYPES_TABLE
			];
		}
		return $items;
	}

}
