<?php

/**
 * webEdition CMS
 *
 * $Rev: 5e052ce534ca $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2019-03-25 21:22 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_navigationCopyFolder extends we_rpc_cmd{

	function execute(){
		$resp = new we_rpc_response();
		$targetFolder = we_base_request::_(we_base_request::FILE, 'we_cmd', false, 0);
		$sourceFolderID = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3);

		if($targetFolder &&
				($targetFolderID = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1)) &&
				($sourceFolder = we_base_request::_(we_base_request::FILE, 'we_cmd', '', 2)) &&
				$sourceFolderID &&
				(strpos($sourceFolder, $targetFolder) === false || strpos($sourceFolder, $targetFolder) > 0)
		){

			$db = $GLOBALS['DB_WE'];
			$sourceFolder = f('SELECT Path FROM ' . NAVIGATION_TABLE . ' WHERE ID=' . $sourceFolderID);
			$result = $db->getAllq('SELECT * FROM ' . NAVIGATION_TABLE . ' WHERE Path LIKE "' . $db->escape($sourceFolder) . '/%" ORDER BY IsFolder DESC,Path ASC');

			$folders = [$targetFolderID];
			$mapedId = [$sourceFolderID => [$targetFolderID, $targetFolder]];
			$itemsQuery = [];
			$now = time();

			foreach($result as $row){
				$rowInsert = $row;
				$rowInsert['ID'] = sql_function('DEFAULT');
				$oldparent = $row['ParentID'];
				if(!isset($mapedId[$oldparent])){
					t_e('Parentid not found', $oldparent, $mapedId);
				}
				$rowInsert['ParentID'] = $mapedId[$oldparent][0];
				$rowInsert['Path'] = $mapedId[$oldparent][1] . '/' . $row['Text'];
				$rowInsert['ModifierID'] = 0;
				$rowInsert['ModDate'] = 0;
				$rowInsert['CreationDate'] = $now;
				$rowInsert['CreatorID'] = empty($_SESSION['user']['ID']) ? 0 : $_SESSION['user']['ID'];

				$querySet = we_database_base::arraySetter($rowInsert, ',', true);
				if($row['IsFolder']){
					$db->query('INSERT INTO ' . NAVIGATION_TABLE . ' VALUES ' . $querySet);
					$newID = $db->getInsertId();
					$mapedId[$row['ID']] = [$newID, $rowInsert['Path']];
					$folders[] = $newID;
				} else {
					$itemsQuery[] = $querySet;
				}
			}
			if($itemsQuery){
				$db->query('INSERT INTO ' . NAVIGATION_TABLE . ' VALUES ' . implode(',', $itemsQuery));
			}
			foreach($folders as $folder){
				$newNavi = new we_navigation_navigation($folder);
				$newNavi->save(false, true);
			}
			we_navigation_cache::delNavigationTree($targetFolderID);
			$resp->setData('status', 'ok');
			$resp->setData('folders', $folders);
		} else {
			$resp->setData('folders', '');
		}

		return $resp;
	}

}
