<?php

/**
 * webEdition CMS
 *
 * $Rev: ed6a0023db08 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-08-27 22:18 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_position extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){

		//	type is required !!!
		if(($missingAttrib = self::attributeMissing($attribs, 'type', __CLASS__))){
			echo $missingAttrib;
			return '';
		}

		//	here we get the needed attributes
		$reference = self::getAttribute('reference', $attribs, '', we_base_request::STRING);
		$format = self::getAttribute('format', $attribs, 1, we_base_request::STRING);

		switch(($type = self::getAttribute('type', $attribs, '', we_base_request::STRING))){
			case 'listview' : //	inside a listview, we take direct global listview object
				return self::formatOutput($format, (we_tag_listview::$current->start + we_tag_listview::$current->count));
			case 'listdir' : //	inside a listview
				return self::formatOutput($format, we_tag_listdir::$position['position']);
			case 'linklist' : //	look in fkt we_tag_linklist and class we_linklist for details
				$missingAttrib = self::attributeMissing($attribs, 'reference', __CLASS__); // seperate because of #6890
				if($missingAttrib){
					echo $missingAttrib;
					return '';
				}
				foreach($GLOBALS['we_position'][$type] as $name => $arr){
					if(strpos($name, $reference) === 0 && is_array($arr)){
						return self::formatOutput($format, $arr['position']);
					}
				}
				return '';
			case 'block' : //	look in function we_tag_block for details
				//	first we must get right array !!!
				$missingAttrib = self::attributeMissing($attribs, 'reference', __CLASS__);
				if($missingAttrib){
					echo $missingAttrib;
					return '';
				}
				if(empty($GLOBALS['we_position'][$type])){
					return '';
				}
				foreach($GLOBALS['we_position'][$type] as $name => $arr){
					if(strpos($name, $reference) === 0 && is_array($arr)){
						return self::formatOutput($format, $arr['position']);
					}
				}
				return '';
			default:
				return '';
		}
	}

	private static function formatOutput($format, $retPos){
		//	convert to desired format
		switch($format){
			case 'a' :
				return we_base_util::number2System($retPos);
			case 'A' :
				return strtoupper(we_base_util::number2System($retPos));
			default:
				return $retPos;
		}
	}

}

function we_tag_position(array $attribs){
	return we_tag_position::tag($attribs);
}
